package com.io.yutian.elementoriginlib.command;

import java.util.HashMap;
import java.util.Map;

public class SenderRequires {

    public static final SenderRequire CONSOLE = (sender) -> sender instanceof org.bukkit.command.ConsoleCommandSender;

    public static final SenderRequire PLAYER = (sender) -> sender instanceof org.bukkit.entity.Player;

    private static Map<String, SenderRequire> requireMap = new HashMap<>();

    public static void register(String name, SenderRequire require) {
        requireMap.put(name, require);
    }

    public static SenderRequire get(String name) {
        return requireMap.get(name);
    }

    static {

        register("console", CONSOLE);
        register("player", PLAYER);

    }

}
