package com.io.yutian.elementoriginlib.command.list;

import com.io.yutian.elementoriginlib.command.CommandContext;
import com.io.yutian.elementoriginlib.command.interfaces.Command;
import com.io.yutian.elementoriginlib.command.interfaces.SubCommand;
import com.io.yutian.elementoriginlib.command.interfaces.Parameter;
import com.io.yutian.elementoriginlib.item.OriginItem;
import com.io.yutian.elementoriginlib.item.stat.ItemStats;
import com.io.yutian.elementoriginlib.item.stat.data.StringData;
import com.io.yutian.elementoriginlib.item.stat.list.IdStat;
import org.bukkit.Material;
import org.bukkit.entity.Player;
import org.bukkit.inventory.ItemStack;

@Command("test")
public class CommandTest {

    @SubCommand("list")
    public void list(CommandContext context, @Parameter(required = false, defaultValue = "1") int page) {
        System.out.println(context.getSender());
        System.out.println("list:"+page);
    }

    @SubCommand("item.get")
    public void item_get(CommandContext context) {
        Player player = (Player) context.getSender();

        OriginItem originItem = new OriginItem(new ItemStack(Material.IRON_AXE));
        originItem.setStatData(ItemStats.getItemStat(IdStat.class), new StringData("test"));
        player.getInventory().addItem(originItem.getItemStack());
    }

    @SubCommand("item.load")
    public void item_load(CommandContext context) {
        Player player = (Player) context.getSender();
        ItemStack itemStack = player.getInventory().getItemInMainHand();
        if (itemStack == null || itemStack.getType() == Material.AIR) {
            return;
        }
        OriginItem originItem = new OriginItem(itemStack);
        System.out.println(originItem.getStats());
    }

    @SubCommand("item.test")
    public void item_test(@Parameter String id) {
        System.out.println(id);
    }
}
