package com.io.yutian.elementoriginlib.datasync;

import com.io.yutian.elementoriginlib.ElementOriginLib;
import com.io.yutian.elementoriginlib.serialize.SerializeHelper;
import redis.clients.jedis.Jedis;

public class DataSyncHelper {

    public static void saveData(String key, Object value) {
        String strValue = SerializeHelper.serialize(value);
        try (Jedis jedis = ElementOriginLib.getRedisIO().getJedisPool().getResource()) {
            jedis.set(key, strValue);
        }
    }

    public static <T> T getData(String key, Class<T> clazz) {
        try (Jedis jedis = ElementOriginLib.getRedisIO().getJedisPool().getResource()) {
            if (!jedis.exists(key)) {
                return null;
            }
            String strValue = jedis.get(key);
            if (strValue == null) {
                return null;
            }
            return SerializeHelper.deserialize(strValue, clazz);
        }
    }

}
