package com.io.yutian.elementoriginlib.item.stat.type;

import com.io.yutian.elementoriginlib.item.OriginItemStackBuilder;
import com.io.yutian.elementoriginlib.item.stat.ItemStat;
import com.io.yutian.elementoriginlib.item.stat.data.BooleanData;
import com.io.yutian.elementoriginlib.tag.TagByte;
import com.io.yutian.elementoriginlib.tag.ItemProxy;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

public abstract class BooleanStat extends ItemStat<BooleanData> {

    public BooleanStat(@NotNull String id, @NotNull String path) {
        super(id, path);
    }

    @Override
    public void whenApplied(@NotNull OriginItemStackBuilder itemStackBuilder, @NotNull BooleanData statData) {
        ItemProxy itemProxy = itemStackBuilder.getNBTItem();
        itemProxy.editTag(nbtCompound -> nbtCompound.putByte(getNBTPath(), (byte) (statData.getValue() ? 1 : 0)));
    }

    @Nullable
    @Override
    public BooleanData getLoadedNBT(@NotNull ItemProxy itemProxy) {
        return new BooleanData(((TagByte) itemProxy.get(getNBTPath())).getByte() == 1);
    }

}
