package com.io.yutian.elementoriginlib.item.stat.type;

import com.io.yutian.elementoriginlib.item.OriginItemStackBuilder;
import com.io.yutian.elementoriginlib.item.stat.ItemStat;
import com.io.yutian.elementoriginlib.item.stat.data.DoubleData;
import com.io.yutian.elementoriginlib.tag.TagDouble;
import com.io.yutian.elementoriginlib.tag.ItemProxy;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

public abstract class DoubleStat extends ItemStat<DoubleData> {

    public DoubleStat(@NotNull String id, @NotNull String path) {
        super(id, path);
    }

    @Override
    public void whenApplied(@NotNull OriginItemStackBuilder itemStackBuilder, @NotNull DoubleData statData) {
        ItemProxy itemProxy = itemStackBuilder.getNBTItem();
        itemProxy.editTag(nbtCompound -> nbtCompound.putDouble(getNBTPath(), statData.getValue()));
    }

    @Nullable
    @Override
    public DoubleData getLoadedNBT(@NotNull ItemProxy itemProxy) {
        return new DoubleData(((TagDouble) itemProxy.get(getNBTPath())).getDouble());
    }

}
