package com.io.yutian.elementoriginlib.item.stat.type;

import com.io.yutian.elementoriginlib.item.OriginItemStackBuilder;
import com.io.yutian.elementoriginlib.item.stat.ItemStat;
import com.io.yutian.elementoriginlib.item.stat.data.StringData;
import com.io.yutian.elementoriginlib.tag.ItemProxy;
import com.io.yutian.elementoriginlib.tag.TagString;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

public abstract class StringStat extends ItemStat<StringData> {

    public StringStat(@NotNull String id, @NotNull String path) {
        super(id, path);
    }

    @Override
    public void whenApplied(@NotNull OriginItemStackBuilder itemStackBuilder, @NotNull StringData statData) {
        ItemProxy itemProxy = itemStackBuilder.getNBTItem();
        itemProxy.editTag(nbtCompound -> nbtCompound.putString(getNBTPath(), statData.getString()));
    }


    @Nullable
    @Override
    public StringData getLoadedNBT(@NotNull ItemProxy itemProxy) {
        return new StringData(((TagString) itemProxy.get(getNBTPath())).getString());
    }

}
