package com.io.yutian.elementoriginlib.logger;

import org.bukkit.Bukkit;

import java.util.logging.Level;

public class Logger {

    private Class clazz;
    protected String formatClassName;

    private Logger(Class clazz) {
        this.clazz = clazz;
        this.formatClassName = getFormatClassName(clazz, 2);
    }

    public String getFormatClassName() {
        return formatClassName;
    }

    protected String getFormatClassName(Class clazz, int keepChars) {
        String className = clazz.getName();
        String[] parts = className.split("\\.");
        StringBuilder abbreviated = new StringBuilder();
        for (int i = 0; i < parts.length; i++) {
            if (i < parts.length - 1) {
                abbreviated.append(parts[i].substring(0, Math.min(keepChars, parts[i].length()))).append(".");
            } else {
                abbreviated.append(parts[i]);
            }
        }
        return abbreviated.toString();
    }

    private String getPrefix(String type) {
        return "[" + clazz.getSimpleName() +"] ";
    }

    public void info(String msg) {
        Bukkit.getLogger().info(getPrefix("INFO")+ msg);
    }

    public void warn(String msg) {
        Bukkit.getLogger().warning(getPrefix("WARN") + msg);
    }

    public void error(String msg) {
        Bukkit.getLogger().log(Level.SEVERE, getPrefix("ERROR") + msg);
    }

    public void fatal(String msg) {
        Bukkit.getLogger().log(Level.SEVERE, "[!!!] "+getPrefix("FATAL") + msg);
    }

    public void debug(String msg) {
        Bukkit.getLogger().finer(getPrefix("DEBUG") + msg);
    }


    public static Logger getLogger(Class clazz) {
        return new Logger(clazz);
    }

}
