package com.io.yutian.elementoriginlib.manager;

import com.io.yutian.elementoriginlib.ElementOriginLib;
import com.io.yutian.elementoriginlib.chatinput.PlayerChatInput;
import org.bukkit.entity.Player;
import org.bukkit.scheduler.BukkitRunnable;

import java.util.HashMap;
import java.util.Map;
import java.util.UUID;

public class PlayerChatInputManager {

    private static Map<UUID, PlayerChatInput> inputMap = new HashMap<>();

    public static boolean hasInput(Player player) {
        return inputMap.containsKey(player.getUniqueId());
    }

    public static PlayerChatInput getInput(Player player) {
        return inputMap.get(player.getUniqueId());
    }

    public static void addInput(Player player, PlayerChatInput playerInput) {
        inputMap.put(player.getUniqueId(), playerInput);
        new BukkitRunnable() {
            @Override
            public void run() {
                if (playerInput.isTimeOut() || playerInput.isCancel()) {
                    if (!playerInput.isCall() && inputMap.containsValue(playerInput)) {
                        playerInput.timeOut();
                        player.sendMessage("playerchatinput.timeout");
                    }
                }
                removeInput(player);
            }
        }.runTaskLater(ElementOriginLib.inst(), 15 * 20L);
    }

    public static void removeInput(Player player) {
        inputMap.remove(player.getUniqueId());
    }

}