package com.io.yutian.elementoriginlib.serialize.serializers;

import com.fasterxml.jackson.core.JacksonException;
import com.fasterxml.jackson.core.JsonParser;
import com.fasterxml.jackson.databind.DeserializationContext;
import com.fasterxml.jackson.databind.JsonDeserializer;
import com.io.yutian.elementoriginlib.tag.TagHelper;
import net.minecraft.core.HolderLookup;
import net.minecraft.nbt.CompoundTag;
import net.minecraft.server.MinecraftServer;
import org.bukkit.craftbukkit.inventory.CraftItemStack;
import org.bukkit.inventory.ItemStack;
import org.json.JSONObject;

import java.io.IOException;

public class ItemStackDeserializer extends JsonDeserializer<ItemStack> {

    @Override
    public ItemStack deserialize(JsonParser jsonParser, DeserializationContext deserializationContext) throws IOException, JacksonException {
        CompoundTag compoundTag = (CompoundTag) TagHelper.jsonToTag(new JSONObject(jsonParser.readValueAsTree().toString()));
        net.minecraft.world.item.ItemStack nmsItemStack = net.minecraft.world.item.ItemStack.parse(getRegistry(), compoundTag).get();
        return CraftItemStack.asCraftMirror(nmsItemStack);
    }

    public static HolderLookup.Provider getRegistry() {
        MinecraftServer minecraftServer = MinecraftServer.getServer();
        return minecraftServer.registryAccess();
    }

}
