package com.io.yutian.elementoriginlib.tag;

import java.util.Arrays;

public class TagByteArray implements ITag {

    public static byte TYPE_ID = 7;

    private byte[] value;

    public TagByteArray(byte[] value) {
        this.value = value;
    }

    public byte[] getByteArray() {
        return this.value;
    }

    @Override
    public Object getValue() {
        return this.value;
    }

    @Override
    public byte getTypeId() {
        return TYPE_ID;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        TagByteArray that = (TagByteArray) o;
        return Arrays.equals(value, that.value);
    }

    @Override
    public int hashCode() {
        return Arrays.hashCode(value);
    }

    @Override
    public String toString() {
        return "NBTByteArray{" +
                "value=" + Arrays.toString(value) +
                '}';
    }
}
